#include <SoftwareSerial.h>
#include <String.h>
 
SoftwareSerial sim900(7, 8);

int statusConnection;
String resposta;
 
void setup() {
  sim900.begin(19200);  // the GPRS baud rate   
  Serial.begin(19200);    // the GPRS baud rate 
  delay(3000);
  statusConnection = 0;
}  
 
void loop() {
    resposta = String("");
    if ((statusConnection == 0)) {
        Serial.println("Entrou no Loop");
        tcpCreateConnection("150.162.10.20", "54321");
    }
    ShowSerialData();
    if (Serial.available() != 0) {
    	while(Serial.available() != 0) {
	        resposta.concat((char) Serial.read());
       }
    }

    if (resposta.length() > 0) {
    	sim900.print(resposta);
    }
}

 
///SendTCP(destination, port)
///this function is to send TCP message

boolean tcpCreateConnection(String destination, String port) {

  if (!sendCommandAndWaitResp("AT+CIPSHUT", "OK", 3, 3000)) {
      return false;
  }

  if (!sendCommandAndWaitResp("AT+CIPMUX=0", "OK", 3, 100)) {
      return false;
  }

  if (!sendCommandAndWaitResp("AT+CIPMODE=1", "OK", 3, 100)) {
      return false;
  }
  
  if (!sendCommandAndWaitResp("AT+CGATT?", "OK", 3, 100)) {
      return false;
  }
  
  if (!sendCommandAndWaitResp("AT+CSTT=\"tim.br\", \"tim\", \"tim\"", "OK", 3, 100)) { //start task and setting the APN,
      return false;
  }
  
  if (!sendCommandAndWaitResp("AT+CIICR", "OK", 3, 4000)) { //bring up wireless connection
      return false;
  }
 
  if (!sendCommandAndWaitResp("AT+CIFSR", ".", 3, 3000)) { //get local IP adress
      return false;
  }
 
  if (!sendCommandAndWaitResp("AT+CIPSTART=\"tcp\",\"" + destination + "\",\"" + port + "\"", "CONNECT", 3, 1000)) {//start up the connection
      return false;
  } else {
        Serial.println("Conectou!");
      statusConnection = 1;
      return true;
  }
  
}


void sendMessage(String message)
{
  sim900.print(message + "\n");
  debugMessage("Enviando mensagem: " + message);
}

boolean sendCommandAndWaitResp(String comando, String respostaEsperada, int tentativas, int delayEntreTentativas) {
    String resposta;
    while (tentativas > 0) {

        sim900.println(comando);
        delay(delayEntreTentativas);

        resposta = "";
        while(sim900.available()!=0) {
            resposta.concat((char)sim900.read());
        }

        if (resposta.indexOf(respostaEsperada) >= 0) {
            debugMessage("OK Comando: " + comando + " Resposta esperada: " + respostaEsperada);
            return true;
        }
        tentativas--;
    }
    debugMessage("ERRO Comando : " + comando + " Resposta esperada: " + respostaEsperada + "Resposta recebida: " + resposta);
    return false;
}


void tcpCloseConnection()
{
  sim900.println("AT+CIPCLOSE");//close the connection
  delay(100);
  ShowSerialData();
}

void ShowSerialData() {
  String resposta;
  while(sim900.available()!=0) {
    resposta.concat((char)sim900.read());
  }

  if (resposta.indexOf("CLOSED") >= 0) {
    debugMessage("!!! SERVER DOWN !!!");
    statusConnection = 0;
  }

    if(resposta.length() > 0) {
      Serial.println(resposta);
    }
}

void debugMessage(String msg)
{
    Serial.println("DEBUG: " + msg);
}
